
var fadeFontSize = 16;

document.onreadystatechange = function()
{
	if(document.readyState == "complete")
	{
		try 
		{
			// Gadget code
			System.Gadget.settingsUI = "settings.html";
			System.Gadget.onSettingsClosed = SettingsClosed;
		}
		catch(err)
		{
		}
		init();
	}
}

function init()
{
     dockStateChanged();
}

// Declare the dock and undock event handlers.
System.Gadget.onDock = dockStateChanged;
System.Gadget.onUndock = dockStateChanged;

// called when the docked state changes
function dockStateChanged()
{
	var root = document.getElementById("rootdiv");
	//Remove all child nodes (icons)
	if ( root.hasChildNodes() )
    {
        while ( root.firstChild )
        {
            root.removeChild(root.firstChild);       
        } 
    }
    
    generateIcons(root); 
    
    setSize();
}

function setSize()
{

    var calculatedwidth = 4*(parseInt(getSetting('IconSize',defaultIconSize))+2*parseInt(getSetting('IconMargin',defaultIconMargin)));
    var calculatedheight = (parseInt(getSetting('IconSize',defaultIconSize))+2*parseInt(getSetting('IconMargin',defaultIconMargin)));
        
    if (System.Gadget.docked)
    {
        document.body.style.width = "130px";
        document.body.style.height = 2*calculatedheight+"px";
    } 
    else 
    {  
        document.body.style.width = calculatedwidth;
        document.body.style.height = calculatedheight+"px";
    }
}

var filesystem  = new ActiveXObject("Scripting.FileSystemObject"); 
var linkcount;

function generateIcons(element)
{   
    //Get windows path  
    var windowsPath = System.Shell.knownFolderPath("Windows");
	     	
    //Restart icon...
    var a_restart = document.createElement('a');
    a_restart.target = "_self";
    a_restart.href="#";
    a_restart.onclick=function(){FollowLink(encodeURI(windowsPath +'\\system32\\shutdown'),encodeURI('-r -f -t 0'));};
    var img_restart = document.createElement('img');
    img_restart.border = 0;
    if(getSetting("ShowTitle",defaultShowTitle) == "2")
    {
        img_restart.onmouseover= function(){showPopup("Restart");};
        img_restart.onmouseout= function(){hidePopup()};
    }
    img_restart.style.margin = getSetting("IconMargin",defaultIconMargin);
    img_restart.src = "images\\restart.gif";
    img_restart.width = getSetting("IconSize",defaultIconSize);
    img_restart.height = getSetting("IconSize",defaultIconSize);
    a_restart.appendChild(img_restart);
    	    
    //Sleep icon...
    var a_sleep = document.createElement('a');
    a_sleep.target = "_self";
    a_sleep.href="#";
    a_sleep.onclick=function()
    {
        FollowLink(encodeURI(System.Gadget.path + '\\scripts\\sleep.bat'),'');
        
        //Turn hibernation off
        //FollowLink(encodeURI(windowsPath +'\\system32\\powercfg'),encodeURI('-h off'));
        //With hibernation off this will result in a suspend... (the last parameters 0,1,0 seems to be ignored...)
        //FollowLink(encodeURI(windowsPath +'\\system32\\rundll32'),encodeURI('powrprof.dll,SetSuspendState 0,1,0'));
        //Turn hibernation back on
        //FollowLink(encodeURI(windowsPath +'\\system32\\powercfg'),encodeURI('-h on'));
    };
    var img_sleep = document.createElement('img');
    img_sleep.border = 0;
    if(getSetting("ShowTitle",defaultShowTitle) == "2")
    {
        img_sleep.onmouseover= function(){showPopup("Sleep");};
        img_sleep.onmouseout= function(){hidePopup()};
    }
    img_sleep.style.margin = getSetting("IconMargin",defaultIconMargin);
    img_sleep.src = "images\\sleep.gif";
    img_sleep.width = getSetting("IconSize",defaultIconSize);
    img_sleep.height = getSetting("IconSize",defaultIconSize);
    a_sleep.appendChild(img_sleep);
    
    //Hibernate icon...
    var a_hibernate = document.createElement('a');
    a_hibernate.target = "_self";
    a_hibernate.href="#";
    a_hibernate.onclick=function()
    {
        FollowLink(encodeURI(System.Gadget.path + '\\scripts\\hibernate.bat'),'');
        
        //Turn hibernation on
        //FollowLink(encodeURI(windowsPath +'\\system32\\powercfg'),encodeURI('-h on'));
        //This will now result in hibernation
        //FollowLink(encodeURI(windowsPath +'\\system32\\rundll32'),encodeURI('powrprof.dll,SetSuspendState 1,1,0'));
    };
    var img_hibernate = document.createElement('img');
    img_hibernate.border = 0;
    if(getSetting("ShowTitle",defaultShowTitle) == "2")
    {
        img_hibernate.onmouseover= function(){showPopup("Hibernate");};
        img_hibernate.onmouseout= function(){hidePopup()};
    }
    img_hibernate.style.margin = getSetting("IconMargin",defaultIconMargin);
    img_hibernate.src = "images\\hibernate.gif";
    img_hibernate.width = getSetting("IconSize",defaultIconSize);
    img_hibernate.height = getSetting("IconSize",defaultIconSize);
    a_hibernate.appendChild(img_hibernate);
        
    //Shutdown icon...
    var a_shutdown = document.createElement('a');
    a_shutdown.target = "_self";
    a_shutdown.href = "#";
    a_shutdown.onclick=function(){FollowLink(encodeURI(windowsPath +'\\system32\\shutdown'),encodeURI('-s -f -t 0'));};
    var img_shutdown = document.createElement('img');
    img_shutdown.border = 0;
    if(getSetting("ShowTitle",defaultShowTitle) == "2")
    {
        img_shutdown.onmouseover= function(){showPopup("Shutdown");};
        img_shutdown.onmouseout= function(){hidePopup()};
    }
    img_shutdown.style.margin = getSetting("IconMargin",defaultIconMargin);
    img_shutdown.src = "images\\shutdown.gif";
    img_shutdown.width = getSetting("IconSize",defaultIconSize);
    img_shutdown.height = getSetting("IconSize",defaultIconSize);
    a_shutdown.appendChild(img_shutdown);
    	
    element.appendChild(a_restart);
    element.appendChild(a_sleep);
    if (System.Gadget.docked)
        element.appendChild(document.createElement("br"));
    element.appendChild(a_hibernate);
    element.appendChild(a_shutdown);
    //element.appendChild(document.createElement('br'));	   
}

function FollowLink(fpath,args)
{
	fpath = decodeURI(fpath);
	args = decodeURI(args);
	try
	{
	    
		// Gadget code
		System.Shell.execute(fpath,args);
		event.returnValue = false;
		return false;
	} catch(err) { alert("Error while following Link: " +err.name +" - "+ err.message)}
}

function SettingsClosed(event) {
    // User hits OK on the settings page.
    if (event.closeAction == event.Action.commit)
    {
		init();
    }
    // User hits Cancel on the settings page.
    else if (event.closeAction == event.Action.cancel)
    {
    	
    }
}