
document.onreadystatechange = function()
{
	 if(document.readyState == "complete")
	 {
		readValues();
		
		document.getElementById('reset').onclick = function()
		{
		    setDefaults();			
		}

		try
		{
			// Gadget code
			System.Gadget.onSettingsClosing = SettingsClosing;
		} catch(err) { alert(err) }	
	}
}

function setDefaults()
{
	// Show title
	setSelectedValue(document.getElementById("ShowTitle"),defaultShowTitle);
	// Show title color
	setSelectedValue(document.getElementById("ShowTitleColor"),defaultShowTitleColor);
	// IconSize
	document.getElementById("IconSize").value = defaultIconSize;	
	// IconMargin
	document.getElementById("IconMargin").value = defaultIconMargin;
	// FontSize
	setSelectedValue(document.getElementById("FontSize"),defaultFontSize);
}

function readValues()
{
	// ShowTitle
	setSelectedValue(document.getElementById("ShowTitle"),getSetting('ShowTitle', defaultShowTitle));
	// ShowTitleColor
	setSelectedValue(document.getElementById("ShowTitleColor"),getSetting('ShowTitleColor', defaultShowTitleColor));
	// IconSize
	document.getElementById("IconSize").value = getSetting('IconSize', defaultIconSize);	
	// IconMargin
	document.getElementById("IconMargin").value = getSetting('IconMargin', defaultIconMargin);
	// FontSize
	setSelectedValue(document.getElementById("FontSize"),getSetting('FontSize', defaultFontSize));
}

function SettingsClosing(event) {
    if (event.closeAction == event.Action.commit) {
        //ShowTitle
	    var dropdownIndex2 = document.getElementById('ShowTitle').selectedIndex;
	    var selected = document.getElementById('ShowTitle')[dropdownIndex2].value;
        System.Gadget.Settings.write("ShowTitle", selected);
        //ShowTitleColor
	    var dropdownIndex3 = document.getElementById('ShowTitleColor').selectedIndex;
	    var selected2 = document.getElementById('ShowTitleColor')[dropdownIndex3].value;
        System.Gadget.Settings.write("ShowTitleColor", selected2);
        //IconSize - test if it is valid number...
        var IconSizeValue = document.getElementById('IconSize').value
        if(isNaN(IconSizeValue) || IconSizeValue<0 || IconSizeValue>512)
            IconSizeValue = defaultIconSize;
        System.Gadget.Settings.write("IconSize", IconSizeValue);
        //IconMargin - test if it is valid number...   
        var IconMarginValue = document.getElementById('IconMargin').value
        if(isNaN(IconMarginValue) || IconMarginValue<0 || IconMarginValue>100)
            IconMarginValue = defaultIconMargin;
        System.Gadget.Settings.write("IconMargin", IconMarginValue);
        //ShowTitle
	    var dropdownIndex4 = document.getElementById('FontSize').selectedIndex;
	    var selected4 = document.getElementById('FontSize')[dropdownIndex4].value;
        System.Gadget.Settings.write("FontSize", selected4);
    }
    event.cancel = false;
}

function setSelectedValue(selectList,value)
{
	for(var i=0;i<selectList.length;i++)
	{
	    if(selectList.options(i).value == value)
	    {
	        selectList.selectedIndex = i;
	        break;
	    }	        
	}
}